package com.xynet.marketing.controller.member;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xynet.marketing.enums.MemberCouponStatusEnum;
import com.xynet.marketing.service.MemberCouponService;
import com.xynet.marketing.service.MercCouponService;
import com.xynet.marketing.utils.MemberAuthUtils;
import com.xynet.marketing.utils.R;
import com.xynet.marketing.utils.collections.map.JHashMap;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * 会员端优惠券控制器
 *
 * @author hechunping
 * @date 2025/2/17
 */
@RestController
@RequestMapping("member/coupon")
@AllArgsConstructor
@Slf4j
@CrossOrigin(origins = "*")
public class MemberCouponController {
    private MercCouponService mercCouponService;
    private MemberCouponService memberCouponService;

    /**
     * 会员优惠券分页
     *
     * @param param
     * @param headers
     * @return
     */
    @PostMapping("page")
    public R page(@RequestBody JHashMap<String, Object> param, @RequestHeader Map<String, String> headers) {
        String thirdMemberId = MemberAuthUtils.getThirdMemberId(headers);
        param.put("thirdMemberId", thirdMemberId);
        Page<Map<String, Object>> data = memberCouponService.page(param);
        return R.ok(data);
    }

    @PostMapping("statusMaps")
    private R statusMaps() {
        return R.ok(MemberCouponStatusEnum.maps());
    }

    @PostMapping("enableList")
    private R enableList(@RequestBody JHashMap<String, Object> param, @RequestHeader Map<String, String> headers) {
        String thirdMemberId = MemberAuthUtils.getThirdMemberId(headers);
        param.put("thirdMemberId", thirdMemberId);
        List<Map<String, Object>> data = memberCouponService.enableList(param);
        return R.ok(data);
    }
}
