package com.xynet.marketing.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 优惠券发放类型枚举
 *
 * @author hechunping
 * @date 2025/2/15
 */
@Getter
@AllArgsConstructor
public enum CouponSendTypeEnum {
    EVERYONE("1", "每人必得", true),
    REGISTER("2", "新注册用户", false),
    SHOPPING("3", "购物后赠送", false),
    DAY("4", "指定日期每日发放", true);

    private String code;

    private String value;

    private Boolean autoSend;


    public static CouponSendTypeEnum getEnum(String code) {
        CouponSendTypeEnum[] values = CouponSendTypeEnum.values();
        for (CouponSendTypeEnum enums : values) {
            if (enums.code.equals(code)) {
                return enums;
            }
        }
        return null;
    }

    public static Map<String, String> maps() {
        Map<String, String> map = new HashMap<>();
        CouponSendTypeEnum[] values = CouponSendTypeEnum.values();
        for (CouponSendTypeEnum enums : values) {
            map.put(enums.code, enums.value);
        }
        return map;
    }

    public static List<String> getEnumByAutoSend(Boolean autoSend) {
        List<String> data = new ArrayList<>();
        CouponSendTypeEnum[] values = CouponSendTypeEnum.values();
        for (CouponSendTypeEnum enums : values) {
            if (enums.autoSend.equals(autoSend)) {
                data.add(enums.getCode());
            }
        }
        return data;
    }
}
