package com.xynet.marketing.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

/**
 * 促销活动状态枚举
 *
 * @author hechunping
 * @date 2025/2/13
 */
@Getter
@AllArgsConstructor
public enum PromotionStatusEnum {
    NOT_START("1", "未开始"),
    UNDERWAY("2", "进行中"),
    FINISHED("3", "已结束"),
    ;
    private String code;

    private String value;

    public static PromotionStatusEnum getEnum(String code) {
        PromotionStatusEnum[] values = PromotionStatusEnum.values();
        for (PromotionStatusEnum enums : values) {
            if (enums.code.equals(code)) {
                return enums;
            }
        }
        return null;
    }

    public static Map<String, String> maps() {
        Map<String, String> map = new HashMap<>();
        PromotionStatusEnum[] values = PromotionStatusEnum.values();
        for (PromotionStatusEnum enums : values) {
            map.put(enums.code, enums.value);
        }
        return map;
    }
}
