package com.xynet.marketing.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xynet.marketing.entity.ProviderApiConfig;
import com.xynet.marketing.mapper.ProviderApiConfigMapper;
import com.xynet.marketing.service.ProviderApiConfigService;
import com.xynet.marketing.utils.Emptys;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author hechunping
 * @date 2025/1/20
 */
@Service
public class ProviderApiConfigServiceImpl extends ServiceImpl<ProviderApiConfigMapper, ProviderApiConfig> implements ProviderApiConfigService {

    private LambdaQueryWrapper<ProviderApiConfig> commonQueryWrapper(JMap<String,Object> param) {
        LambdaQueryWrapper<ProviderApiConfig> lqw = new LambdaQueryWrapper<ProviderApiConfig>()
                .eq(Emptys.check(param.getInt("id")), ProviderApiConfig::getId, param.getInt("id"))
                ;
        return lqw;
    }

    @Override
    public Map<String, Object> obj(JMap<String, Object> param) {
        LambdaQueryWrapper<ProviderApiConfig> lqw = commonQueryWrapper(param).last("limit 1");
        ProviderApiConfig obj = getOne(lqw);
        return JHashMap.copy(obj);
    }

    @Override
    public void saveOrUpdate(JMap<String, Object> param) {
        ProviderApiConfig save = BeanUtil.copyProperties(param, ProviderApiConfig.class);
        if(Emptys.check(save.getId())){
            updateById(save);
        }else{
            save(save);
        }
    }

    @Override
    public List<Map<String, Object>> list(JMap<String, Object> param) {
        LambdaQueryWrapper<ProviderApiConfig> lqw = commonQueryWrapper(param).orderByAsc(ProviderApiConfig::getId);
        List<ProviderApiConfig> list = list(lqw);
        return JHashMap.copy(list);
    }

    @Override
    public Page<Map<String, Object>> page(JMap<String, Object> param) {
        LambdaQueryWrapper<ProviderApiConfig> lqw = commonQueryWrapper(param).orderByAsc(ProviderApiConfig::getId);
        Page<ProviderApiConfig> page = new Page<>(param.getInt("pageNum"), param.getInt("pageSize"), true);
        Page<ProviderApiConfig> list = page(page, lqw);
        return JHashMap.copy(list);
    }
}
